unit config;
{
  Configuration Unit
  Written by Scott Bradshaw
  5/22/99
}

interface
function openconfig(f:string) :boolean;
procedure closeconfig;
function ReadWord(cat,name:string) : word;
function ReadString(cat,name:string) : string;
function ReadBoolean(cat,name:string) :boolean;
implementation

uses crt;
var infile:text;
    fileopen:boolean;


function upstring(s:string) : string;
  var
    os:string;
    i:integer;
  begin
    os := '';
    for i := 1 to length(s) do os := os + upcase(s[i]);
    upstring := os;
  end;

function GotoCat(cat:string) :boolean;
  var
    ins:string;
    catU:string;
    begin
      if fileopen then
      begin
      ins := '';
      catU := '[' +upstring(cat) +']';
      reset(infile);
      while ((not eof(infile)) and (ins <> catu)) do
        begin
          readln(infile,ins);
          if copy(ins,1,1) = '[' then
            begin
              ins := upstring(ins);
            end;
        end;
      end;
     gotocat := (ins = catu);
  end;

function GetLine(v:string) :string;
  var
    ins:string;
    vu:string;
    done:boolean;
    line:string;
    begin
      done := false;
      vu := upstring(v);
      ins := '';
      while ((not eof(infile)) and (not done)) do
        begin
          readln(infile,ins);
          line:=ins;
          if line[1]<>'[' then
          begin
            ins := upstring(copy(ins,1,pos('=',ins)-1));
            if ins=vu then done := true;
          end else { new category found }
          begin
            line := '';
            done:=true;
          end;
        end;
     if line[1] = '#' then line[1] := ';';
     if done then getline := line else getline := '';
  end;

function ReadWord(cat,name:string) : word;
 var ins:string;
     ret,c:word;
  begin
    if not fileopen then exit;
    ins := '';
    reset(infile);
    if gotocat(cat) then
      begin
       ins := getline(name);
       if ins <> '' then
         begin
           ins := copy(ins,pos('=',ins)+1,length(ins));
           while (ins[length(ins)] = ' ') or (ins[length(ins)] = ';') do ins:=copy(ins,1,length(ins)-1);
           val(ins,ret,c);
         end else ret := 0;
     end else ret := 0;
     readword := ret;
  end;

function ReadString(cat,name:string) : string;
 var ins:string;
     category:string;
     ret:string;
  begin
      if not fileopen then exit;
    category := '['+upstring(cat)+']';
    ret := '';
    ins := '';
    reset(infile);
    if gotocat(cat) then
      begin
       ins := getline(name);
       if ins <> '' then ret := copy(ins,pos('=',ins)+1,length(ins))
        else ret := '';
       while (ret[length(ret)] = ' ') or (ret[length(ret)] = ';') do ret:=copy(ret,1,length(ret)-1);
     end;
     readstring := ret;
  end;

function ReadBoolean(cat,name:string) : Boolean;
 var ins:string;
     category:string;
     ret:string;
  begin
      if not fileopen then exit;
    category := '['+upstring(cat)+']';
    ins := '';
    reset(infile);
    if gotocat(cat) then
      begin
       ins := getline(name);
       if ins <> '' then ret := copy(ins,pos('=',ins)+1,length(ins))
        else ret := '';
       while (ret[length(ret)] = ' ') or (ret[length(ret)] = ';') do ret:=copy(ret,1,length(ret)-1);
     end;
     if (ret = '1') or (upstring(ret) = 'TRUE') then readboolean := true else readboolean :=false;
  end;

function openconfig(f:string) :boolean;
  begin
    fileopen := false;
    {$I- }
    assign(infile,f);
    reset(infile); {$I+}
    fileopen := (IOResult = 0);
    openconfig := fileopen;
  end;

procedure closeconfig;
  begin
    if fileopen then close(infile);
  end;

begin
end.