unit gbcomm;
{
James Todd
14th February 2000
}

Interface

procedure goto_line(line: integer);  {move to line to print on (1,2,3,4)}

procedure print_line(out: string); {print string, must be 20 characters}

procedure goto_xy(x: integer; y: integer);  {move for the print_char routine
                                            1<=x<=20;  1<=y<=4}

procedure print_char(c: char);  {print character at current position}

function joypad: Integer;  {Joypad Status, Combination of:
                                   1   :  Right
                                   2   :  Left
                                   4   :  Up
                                   8   :  Down
                                   16  :  A
                                   32  :  B
                                   64  :  Select
                                   128 :  Start
                                   }
procedure clear_scr;       {Clear Gameboy screen, and resets x,y and line}


Implementation


uses crt;

var byte: array[0..7] of integer;
a: integer;
b: string;
c: char;
z: integer;
pow: integer;
clock_out: integer;
l1,l2,l3: string;
count: longint;
bx,by:integer; { Keep track of position }

procedure clock;
begin
     port[888]:=port[888]+2;
     delay(1);
     port[888]:=port[888]-2;
     delay(1);
end;


procedure send_byte(output: array of integer);
begin
for a:=7 downto 0 do
begin
     port[888]:=output[a];
     clock;
end;

end;


procedure receive_byte;
begin
for a:=7 downto 0 do
begin
     if (port[889] AND 32)>0 then byte[a]:=1
     else byte[a]:=0;
     clock;
end;
end;

procedure print_byte(prt_out: array of integer);
begin
     for a:=7 downto 0 do
    write(prt_out[a]);
end;

procedure calc_byte(chr: char);
begin
pow:=1;
for a:=0 to 7 do
begin
     if(ord(chr) and pow)>0 then byte[a]:=1
     else byte[a]:=0;
     pow:=pow*2;
end;
end;

procedure clear_scr;
begin
     calc_byte(Chr(0));
     send_byte(byte);
     delay(40);
     bx:=1; by:= 1; {Update position }
end;

procedure goto_line(line: integer);
begin
     by := line;
     bx := 1;
     calc_byte(Chr(1));
     send_byte(byte);
     delay(40);

     line:=((line-1)*2)+5;
     calc_byte(Chr(line));
     send_byte(byte);
     delay(40);
end;

procedure print_line(out: string);
begin
     calc_byte(Chr(2));
     send_byte(byte);
     delay(40);
     bx := length(out)+1;
     for z:=1 to length(out) do
     begin
          calc_byte(out[z]);
          send_byte(byte);
{          writeln('');}
          delay(40);
     end;
end;

procedure goto_xy(x: integer; y: integer);
begin
     bx := x;
     by := y;

     y:=(y*2)+3;
     x:=x-1;
     calc_byte(Chr(3));
     send_byte(byte);
     delay(40);

     calc_byte(Chr(x));
     send_byte(byte);
     delay(40);

     calc_byte(Chr(y));
     send_byte(byte);
     delay(40);
end;

procedure print_char(c: char);
begin
     goto_xy(bx,by);
     calc_byte(Chr(4));
     send_byte(byte);
     delay(40);

     calc_byte(c);
     send_byte(byte);
     delay(40);
     inc(bx);
end;

Function joypad: Integer;

var
pad: Integer;
loo: Integer;

begin
     pad:=0;
     calc_byte(Chr(5));
     send_byte(byte);
     delay(40);

     receive_byte;
     delay(40);
     for loo:=0 to 7 do
     begin
          if byte[loo]=1 then pad:=pad+ (1 shl loo);
     end;
     joypad:=pad;
end;

end.