unit mp3tag;
{
  MPXT ID3/OGG/APE Tag Unit
}

interface

function songinfo(s:string):string;
implementation
uses dos,crt,mpxfvars,mpxfgen;
{Uses the following: from mpxfvars-UpString;
                     from mpxfgen-GenreLookupTable,GenreLookupTableMax}
type
  tId3Tag = record                                 { Standard ID3 Tag }
             Tag : array[1..3] of char;
             Song, Artist, Album : array[1..30] of char;
             year : array[1..4] of char;
             comment : array[1..30] of char;
             genre : byte;
           end;

{  tFindRecord = record                             { My Find Record, used to }
{                 hasID3Tag : boolean;              { find the tags in a file }
{                 ID3Tag : tId3Tag;
                 DIDTag : boolean;
                 DIDSize : word;
                 DIDStartPos : longint;
                end;}

{const DID    : string = 'DIDTAG';                  { Strings enclosing the }
{      DIDEND : string = 'ENDDID';                  { tag }

 Var                                                { Some variables }
  mpfile : file;
{  genstring : string;}

{  length_of_tag : word;}
{  title, artist, album, software, sampledby, comment, genre, year : string;}

{ Function arrayToString, converts array x to string }

function arrayToString(x: array of char; size : byte) : string;
var resulting : string;
begin;
  resulting[0]:=chr(size);
  move(mem[seg(x):ofs(x)],mem[seg(resulting[1]):ofs(resulting[1])],size);
  arrayToString:=resulting;
end;

function stripend(s:string):string;
  var dest:string;
      i,c:integer;
  begin
     i:=length(s);
     dest := '';
     c:=0;
     while ((s[i] = #0) or (s[i] = #32)) do begin
       inc(c);
       dec(i);
     end;
     dest := copy(s,1,(length(s)-c));
     i:=pos('_',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('_',dest);
     end;
     i:=pos('-',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('-',dest);
     end;
{     i:=pos('''',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('''',dest);
     end;}

{     for i := 1 to length(dest) do dest[i] := upcase(dest[i]);}
     stripend := dest;
  end;


function strip(s:string; st:char): string;
  var
    l:integer;
    b:string;
    begin
      b:='';
      for l := 1 to length(s) do
        if s[l] <> st then b:=b+s[l];
      strip := b;
    end;

{ StringToArray, coverts string s to array x }
procedure StringToArray(var x : array of char;s : string);
begin;
  move(mem[seg(s[1]):ofs(s[1])],mem[seg(x):ofs(x)],ord(s[0]));
end;

{New for MPXT, OGG Tags...making it FLAC compatible too, just in case}
Procedure FindOGGTag(var oggFile: File; var back: String);
 Var
  Song,Artist,Album,Genre: String[30];
  year: String[4];
  numfields,i: byte;
  fileOffs,count: Longint;
  metaBlockType: Byte; {Meta-Block type for FLAC files}
  hasTag, genreFound: Boolean;
  genreI: Byte;
 Begin;
  Hastag:=false;
  Song:=''; Artist:=''; Album:=''; year:=''; genre:='';
{$I-}
  blockread(oggFile,back[1],255);{$I+}
  back[0]:=#255;
  if IOResult = 0 then
   Begin
    fileOffs:=0;
    if copy(back,1,4)='OggS' then          {Locate where the tags start}
     Begin
      i:=pos('vorbis',back)+7;
      count:=ord(back[i])+(ord(back[i+1]) shl 8)+(ord(back[i+2]) shl 16)+
             (ord(back[i+3]) shl 24);      {count: Vendor string length}
      fileOffs:=i+count+3;
     End
      Else if (copy(back,1,4)='fLaC') then {Locate where the tags start}
       begin
        metaBlockType:=ord(back[5]);       {Set count to the metablock length}
        count:=(ord(back[6]) shl 16)+(ord(back[7]) shl 8)+ord(back[8]);
        fileOffs:=4;
        {$I-}
        while (metaBlockType<4) and (IOResult=0) do
         Begin                             {Parse through the metablocks}
          inc(fileOffs,count+4);            {until we get to metablock 4}
          seek(oggFile,fileOffs);
          blockread(oggFile,back[1],255);
          back[0]:=#255;
          metaBlockType:=ord(back[1]);
          count:=(ord(back[2]) shl 16)+(ord(back[3]) shl 8)+ord(back[4]);
         End;
        {$I+}
        if metaBlockType<>4 then           {If we never got to 4, clear}
         fileOffs:=0                        {fileOffs, otherwise setup}
          else                              {count/fileOffs for below}
           count:=ord(back[5])+(ord(back[6]) shl 8)+(ord(back[7]) shl 16)+
                  (ord(back[8]) shl 24);   {count: Vendor string length}
        inc(fileoffs,count+8);             {Skip over the vendor string}
       end;

     if fileOffs>0 then
      Begin
       {$I-}
       seek(oggFile,fileoffs);
       blockread(oggFile,back[1],255);
       back[0]:=#255;                      {Fudging the standard a little.}
       numfields:=ord(back[1]);             {>255 fields is unlikely, though}
       inc(fileoffs,4);                    {Set fileoffs to the 1st field}
       i:=1;                               {Init the field counter to 1}
       while (i<=numFields) and (IORESULT=0) do
        Begin
         seek(oggFile,fileOffs);           {Seek to the the field}
         blockread(oggFile,back[1],255);   {Limiting each field to 255 chars}
         back[0]:=#255;                    {Set the string length to 255}
         if upstring(copy(back,5,6))='TITLE=' then
          Song:=copy(back,11,ord(back[1])-6);
         if upstring(copy(back,5,6))='ALBUM=' then
          Album:=copy(back,11,ord(back[1])-6);
         if upstring(copy(back,5,7))='ARTIST=' then
          Artist:=copy(back,12,ord(back[1])-7);
         if upstring(copy(back,5,6))='GENRE=' then
          Genre:=copy(back,11,ord(back[1])-6);
         count:=ord(back[1])+(ord(back[2]) shl 8)+(ord(back[3]) shl 16)+
                (ord(back[4]) shl 24);     {count: Field length}
         inc(fileOffs,count+4);            {Add the field length + 4}
         inc(i);                           {Increment the field counter}
        End;
       {$I+}
       if length(Song)+length(Album)+length(Artist)+length(Genre)>0 then
        Begin
         hasTag:=true;
         genreFound:=false;
         genreI:=0;
         while (genreI <= GenreLookupTableMax) and (not genreFound) do
          Begin
           if UpString(Genre)=GenreLookupTable[genreI] then
            Begin
             genreFound:=true;
             Str(genreI,Genre);
            End;
           inc(genreI);
          End;
         if not genreFound then Genre:='12';
        End;
      End;
   End;
  if hasTag=true then
   back:=Artist+'-'+Song+'-'+Album+'-'+Genre
    else back:='NoTag';
 End;

{New for MPXT, APE Tags...making it MPC compatible as well}
Procedure FindAPETag(var apeFile: File; var back: String);
 Var
  Song,Artist,Album,Genre: String[30];
  hasTag, genreFound: Boolean;
  fileOffs,count,fileEnd,bytesToRead: Longint;
  tagKey: String;
  tagI: Byte;
 Begin
  hasTag:=false;
  Song:=''; Artist:=''; Album:=''; genre:='';
  {$I-}
  fileEnd:=filesize(apeFile);             {Find the end of the file}
  seek(apeFile,fileEnd-32);               {Read the tag footer}
  blockread(apeFile,back[1],32);{$I+}
  back[0]:=#32;
  if (IOResult = 0) and (copy(back,1,8)='APETAGEX') then
   Begin;                                 {If the footer is valid}
    {Find the total size of all tags plus the size of the footer}
    bytesToRead:=ord(back[13])+(ord(back[14]) shl 8)+(ord(back[15]) shl 16)+
                (ord(back[16]) shl 24);
    fileOffs:=fileEnd-bytesToRead;        {Calcultate the position in file}
    dec(bytesToRead,32);                  {Subract the length of the footer}
    {$I-}
    seek(apeFile,fileOffs);               {Goto the start of the tags}
    if bytesToRead<255 then               {Load the string with tag data}
     Begin
      blockread(apeFile,back[1],bytesToRead); {Blockread was meant to be used}
      back[0]:=chr(bytesToRead);               {with character arrays, but}
     End                                       {with a little bit of arm}
      Else                                     {twisting it can be used with}
       Begin                                   {pascal style strings too}
        blockread(apeFile,back[1],255);
        back[0]:=#255;
       End;                               {While there's data left to read}
    while (bytesToRead>0) and (IORESULT=0) do
     Begin                                {Bytes 1..4: length of item value}
      tagKey:='';                         {Bytes 5..8: flags, not used in APE1}
      tagI:=9;                            {Start at 9, to read tag key/value}
      while back[tagI]<>#0 do             {But the value in bytes 1..4 doesn't}
       Begin                               {include the length of the tag key}
        tagKey:=tagkey+back[tagI];         {so we've got to manually copy the}
        inc(tagI);                         {the stupid thing byte by byte,}
       End;                                {until we find a null character}
      tagkey:=Upstring(tagkey);           {Tag keys should be case sensitive}
      if tagkey='TITLE' then               {but I'm not taking any chances}
       Begin
        Song:=copy(back,15,ord(back[1]));    {Taking the least significant}
        if Song[length(song)]=#0 then         {byte from the field length}
         delete(Song,length(Song),1);         {and using that for the}
       End                                    {string length, but sometimes}
        else if tagkey='ARTIST' then          {people get the bright idea}
         Begin                                {to include a null terminator}
          Artist:=copy(back,16,ord(back[1])); {a the end of the field data.}
          if Artist[length(Artist)]=#0 then   {Fortunately that pesky null}
           delete(Artist,length(Artist),1);   {character is accounted for}
         End                                  {in field length, but we}
        else if tagkey='ALBUM' then           {still need to check for it}
         Begin                                {to make the strings come out}
          Album:=copy(back,15,ord(back[1]));  {right.  In other works we}
          if Album[length(Album)]=#0 then     {gotta code around other}
           delete(Album,length(Album),1);     {people's indecision}
         End
        else if tagkey='GENRE' then
         Begin
          Genre:=copy(back,15,ord(back[1]));
          if Genre[length(Genre)]=#0 then
           delete(Genre,length(Genre),1);
         End;
      count:=ord(back[1])                  {Set 'count' using all bytes in the}
        +(ord(back[2]) shl 8)               {field length, in case somebody}
        +(ord(back[3]) shl 16)              {decides to write their biography}
        +(ord(back[4]) shl 24);             {in one or more of these fields}
      {Add the length of the tag key plus one for the null character,}
      count:=count+length(tagkey)+9; {plus 8 bytes for item value/flags}
      {If the file is corrupted, count could end up being zero, so make it}
      if count=0 then count:=255; {something else to prevent an infinite loop}
      inc(fileOffs,count);                     {Increment the file offset}
      dec(bytesToRead,count);                  {Decement bytes left to read}
      if bytesToRead+count>255 then       {If > 255 bytes left to read}
       Begin
        seek(apeFile,fileOffs);           {Goto the start of the next tag}
        if bytestoread<255 then           {If the file read won't fill the}
         Begin                             {all 255 characters in the string}
          blockread(apeFile,back[1],bytestoread); {then only read what's}
          back[0]:=chr(bytestoread);              {necessary}
         End
          Else                            {Else fill the entire string}
           Begin
            blockread(apeFile,back[1],255);
            back[0]:=#255;
           End;
       End                                {Else if <= 255 bytes left to read}
        Else                               {make the string begin at the}
         back:=copy(back,count+1,bytesToRead); {start of the next field}
     End;
    {$I+}
    if length(Song)+length(Album)+length(Artist)+length(Genre)>0 then
     Begin
      hasTag:=true;
      genreFound:=false;
      tagI:=0;
      while (tagI <= GenreLookupTableMax) and (not genreFound) do
       Begin
        if UpString(Genre)=GenreLookupTable[tagI] then
         Begin
          genreFound:=true;
          Str(tagI,Genre);
         End;
        inc(tagI);
       End;
      if not genreFound then Genre:='12';
     End;
   End;
  if hasTag=true then
   back:=Artist+'-'+Song+'-'+Album+'-'+Genre
    else back:='NoTag';
 End;

{ From MPXF 1.4
function songinfo(s:string):string;
  var back:string;
      v:string;
begin
  filemode := 0;
  {$I-} {assign(mpfile,s);
  reset(mpfile,1); {$I+}
{ if IOResult = 0 then begin
   findMP3Tag(mpfile,findrec);                       { Search for the tags }
{   if findrec.hasID3Tag then                         { Found ID3 Tag? }
{   with findrec.id3tag do                            { Yes! }
{     begin
       str(genre,v);
       back:=stripend(arrayToString(artist,30))+'-'+stripend(arraytoString(song,30)) +'-';
       back:=back+stripend(arraytoString(album,30))+'-'+v;
     end
   else back:='NoTag';
   close(mpfile);
   filemode := 2;
 end;
{ writeln(back);}
{ songinfo := back;                        { Close the file to }
{end;}

{FindMP3Tag, finds ID3V1 Tags}
Procedure FindMP3Tag(var where: File; var back:string);
 Var
  testarray : array[1..6] of char;
  size : word;
  Id3Tag: tId3Tag;
  hasId3Tag: Boolean;
  v: String[22];
 Begin;
  hasId3Tag:=false;
  fillchar(Id3Tag,sizeof(tId3Tag),0);
  {$I-}
  seek(where,filesize(where)-128);
  blockread(where,Id3Tag,128); {$I+}
  if IOResult = 0 then
  if arrayToString(Id3Tag.tag,3)='TAG' then
   Begin
    hasID3Tag:=true;
   End;
  if hasID3Tag then                                  {Found ID3 Tag?}
   with Id3tag do                                    {Yes!}
    Begin
     str(genre,v);
     back:=stripend(arrayToString(artist,30))+'-'+stripend(arraytoString(song,30)) +'-';
     back:=back+stripend(arraytoString(album,30))+'-'+v;
    End
     Else back:='NoTag';
 End;

Function SongInfo(s: String): String;
 Var
  back: String;
 Begin
  filemode := 0;
  {$I-} assign(mpfile,s);
  reset(mpfile,1); {$I+}
  if IOResult = 0 then
   begin
    if (copy(s,length(s)-3,4)='.MP3') or             {Search for ID3 tags}
       (copy(s,length(s)-3,4)='.MP2') then
     Begin
      findMP3Tag(mpfile,back);
     End
      Else if copy(s,length(s)-3,4)='.OGG' {or       {Search for OGG tags}
            {(copy(s,length(s)-3,4)='.FLA')} then
       FindOGGTag(mpfile,back)
      Else if (copy(s,length(s)-3,4)='.APE') or      {Search for APE tags}
              (copy(s,length(s)-3,4)='.MPC') then
       FindAPETag(mpfile,back)
      Else back:='NoTag';
    close(mpfile);                                   {Close the file}
   end;
  filemode := 2;
  {writeln(back);}
  songinfo := back;
 End;

End.