unit mpxfcprc;

interface

procedure shell(prog:string);
procedure save_settings;
procedure load_settings;

implementation

Uses
 mpxfvars,lcd,config,mpxfir,keystats,crt,keyintr,dos;


procedure save_settings;
var setfile:text;
    i:integer;
  begin
    assign(setfile,'mpxt.ini');
{$I-}    rewrite(setfile); {$I+}
    If IOResult = 0 then
    begin
      writeln(setfile,version);
      writeln(setfile,DefaultDatabase);
      if HelpBoxes then writeln(setfile,'1') else writeln(setfile,'0');
      if GenreSupport then writeln(setfile,'1') else writeln(setfile,'0');
      for i := 1 to GenreTypes do
        if genre[i]^.tag then writeln(setfile,'1') else writeln(setfile,'0');
      for i := 1 to numplayoptions do
        if PlayOptions[i]^.tag then writeln(setfile,'1') else writeln(setfile,'0');

      if loop then writeln(setfile, '1') else writeln(setfile,'0');

      close(setfile);
    end else writeln('error writing mpxt.ini file.');
  end;

procedure load_settings;
 var setfile:text;
     input:string;
     i:integer;
     a:string;
     cv:string;
     yn:boolean;
     b:byte;
  begin

  CmdString := ReadString('Startup','StartupCommand');
  StartLogo[1] := ReadString('Startup','StartLine1');
  StartLogo[2] := ReadString('Startup','StartLine2');
  StartLogo[3] := ReadString('Startup','StartLine3');
  StartLogo[4] := ReadString('Startup','StartLine4');
  StartDelay := ReadWord('Startup','StartDelay');
  Stars := ReadString('FrontEnd Settings','SearchStars');
  SearchBar := ReadWord('FrontEnd Settings','SearchBarCount');
  SearchBarLine := ReadWord('FrontEnd Settings','SearchBarLine');
  ScreenClearDelay := ReadWord('FrontEnd Settings','ScreenClearDelay');
  mp3prog := ReadString('Player Settings','Player');
  mp3list := ReadString('Player Settings','Database');
  mpxplaynormal:=readstring('Player Settings','MPXPlayNormal');
  mpxplayloop:=readstring('Player Settings','MPXPlayLoop');
  mpxplaylistnormal:=readstring('Player Settings','MPXPlaylistNormal');
  mpxplaylistrandom:=readstring('Player Settings','MPXPlaylistRandom');
  PlayListDir := ReadString('Player Settings','PlaylistDir');
  DatabaseDir := ReadString('Player Settings','DatabaseDir');
  NumLockPlay := ReadBoolean('Player Settings','NumLockOff');
  DrawLogo := ReadBoolean('Frontend Settings','DisplayLogo');

  NetworkUtil := readstring('FrontEnd Settings','NetworkUtil');
  ScrollPause := ReadWord('FrontEnd Settings','ScrollPause');
  ScrollDelay := ReadWord('FrontEnd Settings','ScrollDelay');

  UseIR := (ReadBoolean('IR Settings','UseIR'));
  UseX10 := (ReadBoolean('IR Settings','UseX10'));
  IRSetDelay(ReadWord('IR Settings','Delay'));
  if UseIR or UseX10 then
  begin
    IRPort := ReadWord('IR Settings','Comport');
    irmpxffn := ReadString('IR Settings','MPXF');
    irmpxplayfn := ReadString('IR Settings','MPXPlay');
  end;

  LeftChar := ord('4');
  RightChar := ord('6');
  UpChar := ord('8');
  DownChar := ord('2');
  EnterChar := 13;
  ExitChar := ord('-');
  TagChar := ord('+');
  TagAllChar := ord('*');
  LCDHelpChar := ord('/');
  ScrollToggleChar:=ord('5');
  LoopToggleChar := ord('0');
  JumpChar := ord('+');
  Up10Char := ord('3');
  Down10Char := ord('1');
  mpxfnumone := '1';
  mpxfnumtwo := '2';
  mpxfnumthree := '3';
  mpxfnumfour := '4';
  mpxfnumfive := '5';
  mpxfnumsix := '6';
  mpxfnumseven := '7';
  mpxfnumeight := '8';
  mpxfnumnine := '9';
  mpxfnumzero := '0';

  a := ReadString('Keyboard Settings','LeftChar');
  if (a <> '') then LeftChar := AddKey(a);
  a := ReadString('Keyboard Settings','RightChar');
  if a <> '' then RightChar := AddKey(a);
  a:= ReadString('Keyboard Settings','ExitChar');
  if a <> '' then ExitChar := Addkey(a);
  a := ReadString('Keyboard Settings','UpChar');
  if a <> '' then UpChar := Addkey(a);
  a := ReadString('Keyboard Settings','DownChar');
  if a <> '' then DownChar := Addkey(a);
  a := ReadString('Keyboard Settings','EnterChar');
  if a <> '' then EnterChar := Addkey(a);
  a := ReadString('Keyboard Settings','TagChar');
  if (a <> '') then TagChar := AddKey(a);
  a := ReadString('Keyboard Settings','TagAllChar');
  if (a <> '') then TagAllChar := AddKey(a);
  a := ReadString('Keyboard Settings','LCDHelpChar');
  if (a <> '') then LCDHelpChar := AddKey(a);
  a := ReadString('Keyboard Settings','ScrollToggleChar');
  if (a <> '') then ScrollToggleChar := AddKey(a);
  a := ReadString('Keyboard Settings','LoopToggleChar');
  if (a <> '') then LoopToggleChar := AddKey(a);
  a := ReadString('Keyboard Settings','JumpChar');
  if (a <> '') then JumpChar := AddKey(a);
  a := ReadString('Keyboard Settings','Up10Char');
  if (a <> '') then Up10Char := AddKey(a);
  a := ReadString('Keyboard Settings','Down10Char');
  if (a <> '') then Down10Char := AddKey(a);
  a := ReadString('Keyboard Settings','1');
  if (a <> '') then mpxfnumone := a[1];
  a := ReadString('Keyboard Settings','2');
  if (a <> '') then mpxfnumtwo := a[1];
  a := ReadString('Keyboard Settings','3');
  if (a <> '') then mpxfnumthree := a[1];
  a := ReadString('Keyboard Settings','4');
  if (a <> '') then mpxfnumfour := a[1];
  a := ReadString('Keyboard Settings','5');
  if (a <> '') then mpxfnumfive := a[1];
  a := ReadString('Keyboard Settings','6');
  if (a <> '') then mpxfnumsix := a[1];
  a := ReadString('Keyboard Settings','7');
  if (a <> '') then mpxfnumseven := a[1];
  a := ReadString('Keyboard Settings','8');
  if (a <> '') then mpxfnumeight := a[1];
  a := ReadString('Keyboard Settings','9');
  if (a <> '') then mpxfnumnine := a[1];
  a := ReadString('Keyboard Settings','0');
  if (a <> '') then mpxfnumzero := a[1];


  closeconfig;

    assign(setfile,'mpxt.ini');
    {$I-} reset(setfile); {$I+}
    if IOResult <> 0 then save_settings else
      begin
        readln(setfile,cv);
        if cv <> version then
        begin
          readln(setfile,defaultdatabase);
        end else
        begin
          readln(setfile,DefaultDatabase);
          readln(setfile,input);
          if pos('1',input) > 0 then HelpBoxes := true else HelpBoxes := false;
          readln(setfile,input);
          if pos('1',input) > 0 then GenreSupport := true else GenreSupport := false;
          for i := 1 to GenreTypes do begin
            readln(setfile,input);
            if pos('1',input) > 0 then Genre[i]^.tag := true else Genre[i]^.tag := false;
          end;
          for i := 1 to numplayoptions do begin
            readln(setfile,input);
            if pos('1',input) > 0 then PlayOptions[i]^.tag := true else PlayOptions[i]^.tag := false;
          end;
          readln(setfile,input);
          if pos('1',input) > 0 then loop := true else loop := false;
        end;
        close(setfile);
      end;

  YesStr := 'Yes';
  NoStr := 'No';
  OKStr := 'OK';
  ArtistStr := 'Artist';
  AlbumStr := 'Album';
  SongStr := 'Song';
  songsstr:= 'songs';
  LoadingStr := 'Loading';
  if (openconfig('mpxtlang.cfg') = true) then
  begin
    a:=ReadString('Other Settings','ChoiceNo');
    if a <> '' then NoStr := a;
    a:=ReadString('Other Settings','ChoiceYes');
    if a <> '' then YesStr := a;
    a:=ReadString('Other Settings','ChoiceOK');
    if a <> '' then OKStr := a;
    a:=ReadString('Other Settings','Loading');
    if a <> '' then LoadingStr := a;
    a:=ReadString('Other Settings','Artist');
    if a <> '' then ArtistStr := a;
    a:=ReadString('Other Settings','Album');
    if a <> '' then AlbumStr := a;
    a:=ReadString('Other Settings','Song');
    if a <> '' then SongStr := a;
    a:=ReadString('Other Settings','Songs');
    if a <> '' then SongsStr := a;
    closeconfig;
  end;


  end;

procedure shell(prog:string);
 var emsswap :boolean;
     er:word;
     savedir:string;
     c:char;

  begin
   if prog <> '' then prog := ' /C ' + prog;
       if numlockon and numlockplay then begin
      delay(50);
      Numlock(FALSE);
      storekey(0,ord('a'));
      if keypressed then c:=readkey;
      delay(50);
    end;

   delay(100);
   getdir(0,savedir);

{  Getintvec($1C ,@Old1Cint);
  Setintvec($1C ,@Get_Time);
  doit;

{      lcdcleanup;  Shut off Serial LCD }

      if debug then begin
        writeln('Shelling...');
        writeln(GetEnv('COMSPEC'),' ',prog);
        write('press enter');
        readln;
      end;
{      prog := GetEnv('COMSPEC')+' '+prog;}
      eq_bars;
      IRClearCodes;
      IRLoadConfig(irmpxplayfn);
      er := dosshell(prog);
      IRClearCodes;
      IRLoadConfig(irmpxffn);

      chdir(savedir);
{      readlcdsettings;


      setback;
      lcdready;  {Turn it back ON }
 {      exec(getenv('COMSPEC'),prog);}
{      swapvectors;
      if er <> 0 then{ Error?  begin
        WriteLn('Dos error #', er);  readln; end;}

{   mpxlcdoff;
   swapvectors;}
   lcdtoscreen:=true;
   delay(50);
   initlcd;
   delay(100);
   definestars;
   lcdclear;
   lcdcursoroff;
   delay(100);
   NUMLOCK(true);
  end;
Begin
End.