unit mpxfvars;
{
  MPXF Vars and Common Procedures
}
interface
Uses
 mpxfmem;

CONST
  MaxSearch   = 300;
  DatabaseEmpty = 'No Name';
  mnuPlayDatabase=50;
  mnuPlayDrive=51;
  mnuSearchArtist=30;
  mnuSearchSong=31;
  mnuSearchAlbum=32;
  mnuBrowseHD=60;
  mnuBacktoMain=10;

  mnuSortArtist=100;
  mnuSortAlbum=101;
  mnuSortSong=102;
  mnuSortPath=103;

  mnuDatabaseInfo=20;
  mnuBrowseSongs=21;
  mnuAddMP3=22;
  mnuDatabaseLoad=23;
  mnuDatabaseSave=24;
  mnuDatabaseClear=25;
  mnuDatabaseSort=26;

  mnuHelpBoxes=80;
  mnuUseGenres=81;
  mnuSelectGenres=82;

  mnuIRInfo=90;
  mnuIRAddcode=91;
  mnuIRClearcode=92;
  mnuIRLoadcode=93;
  mnuIRSavecode=94;

  mnuPLPlay=40;
  mnuPLLoad=41;
  mnuPLEdit=42;
  mnuPLSave=43;
  mnuPLClear=44;

  mnuPlayCD=70;
  mnuChangeDisc=71;
  mnuChangeDrive=72;

  mnuPlayOption = 5;


type
  search_rec = record
    songnum : word;
    tag: byte;
    value:byte;
  end;

  menu_type = record
    Display:string[100];
    Data:string[100];
  end;
  menu = array[1..300] of string[40];
  newmenu = array[1..50] of ^menu_type;

  song = array[1..SongSize] of char;
  songname=string[SongSize];
  sresults=array[1..MaxSearch] of search_rec;
  genretype= record
    name : string[40];
    data : string[20];
    tag  : boolean;
  end;
  genres=array[1..35] of ^genretype;
var

  playoptiondata:string;
  playdata:string;

  irmpxffn,irmpxplayfn:string[12];
  IRPort:byte;
  UseIR,UseX10:boolean;
  CmdString:string[100];
  debug:boolean;
  crcfail:boolean;
  DrawLogo:boolean;
  CDRomDefault:byte;
  DefaultDatabase:string[30];
  startlogo:array[1..4] of string[40];
  startdelay:word;
  HelpBoxes:boolean;
  lcdchardelay,lcdcontroldelay:byte;
  lcdport:word;
  GenreSupport:boolean;
{  data:array[1..MaxMem] of string[SongSize];}
  mp3dir,mp3prog,mp3list:string;

    genretypes:word;
  lcdlen:byte;
  lcdlines:byte;
  PlayListDir:string;
  Databasedir:string;
  genre:genres;
  numplayoptions:byte;
  playoptions:genres;
  Scrolling:boolean;
  phone:array[0..9] of string[5];

  mpxplaynormal,
  mpxplayloop,
  mpxplaylistnormal,
  mpxplaylistrandom:string;
  stars:string;

{ Other Vars }
  starcount:integer;
  loop:boolean;
  ScrollPause:word;
  scrolldelay:word;
  PlayList:sresults;
  SongSearch:sresults;
  SongBuild:sresults;
  SongBuildResults:word;
  totalsongs:word;
  SearchBar:word;
  SearchBarLine:byte;
  NetworkUtil:string[100];
  Search:byte;
  numresults:word;
  screencleardelay:word;

  TagChar,
  LeftChar,
  RightChar,
  UpChar,
  DownChar,
  EnterChar,
  ScrollToggleChar,
  LoopToggleChar,
  LCDHelpChar,
  TagAllChar,
  JumpChar,
  Up10Char,Down10Char,
  ExitChar:byte;
  mpxfnumone,
  mpxfnumtwo,
  mpxfnumthree,
  mpxfnumfour,
  mpxfnumfive,
  mpxfnumsix,
  mpxfnumseven,
  mpxfnumeight,
  mpxfnumnine,
  mpxfnumzero : char;
  NumLockPlay:boolean;

  OKStr,YesStr,NoStr:string[10];
  ArtistStr,
  AlbumStr,
  SongStr,
  SongsStr,
  LoadingStr:string[12];
  NextMenu:string[100];
  PlayerHalt:boolean;


Procedure NumLock(ONorOFF:Boolean);
Function DosShell(command:String):Integer;
function strip(s:string; st:char): string;
procedure clear(var asong:song);
procedure LCDCoolClear;
function strr(b:longint):string;
function GetArtist(sn:string):string;
function GetTitle(sn:string):string;
procedure AddPlayOptions(var ps:string);
function GetAlbum(sn:string):string;
function stripend(s:string):string;
function spaces(l:byte):string;
function UpString(dest:string):string;
procedure dostar(line:byte);
function Addkey(ins:string):byte;
procedure eq_bars;
function stripbeg(s:string):string;
function center(ab:string):string;
procedure Help(hmsg:string;var l:byte);
procedure Info(hmsg:string;l:byte);
procedure DefineStars;
procedure LCDOk(l:byte);
function YesNo(l:byte):boolean;
function GetAlpha:string;
function GetKey:char;
function Keypress:boolean;
function CmdNext:char;
function CmdEmpty:boolean;
procedure CmdPop;
implementation
uses xms,lcd,keystats,crt,keyintr,dos,config{,mpxfir,mpxfmenu};



procedure LCDCoolClear;
  var i,j,k:word;
      od1,od2:byte;
      l:byte;
      step:byte;
      a:string;
  begin
    if GetLCDType <> 3 then
    begin
        for i:= 0 to 2 do begin
          for l := 1 to lcdlines do
          begin
            lcdcursor(l,1);
            j := 1;
            while (j<lcdlen) do
            begin
              j:=j + 1;
              a := chr(i);
              lcdprint(a);
              for k := 1 to ScreenClearDelay do ;
            end;
          end;
        end;
        for i:= 2 downto 0 do begin
          for l := 1 to lcdlines do
          begin
            lcdcursor(l,1);
            j := 1;
            while (j<lcdlen) do
            begin
              j:=j + 1;
              a := chr(i);
              lcdprint(a);
              for k := 1 to ScreenClearDelay do;

            end;
          end;
        end;
      end;
     lcdclear;
    lcdcursoroff;
 end;

function CmdEmpty:boolean;
  begin
    if CmdString = '' then CmdEmpty := true else CmdEmpty := false;
  end;

procedure CmdPop;
  begin
    if (not CmdEmpty) then
    begin
      cmdString := copy(cmdstring,3,length(cmdstring));
    end;
  end;

function CmdNext:char;
  begin
    if (not CmdEmpty) then CmdNext := CmdString[1] else CmdNext := #0;
  end;

function Keypress:boolean;
 begin
   if Keypressed then keypress:=true else keypress:=false;
 end;

function GetKey:char;
  begin
    getkey := readkey;
  end;

function YesNo(l:byte):boolean;
  var
    yn:boolean;
    c:char;
    begin
      yn:=true;
      if (not cmdempty) then c:= upcase(cmdnext);
      if (c='Y') or (c='N') then
      begin
        cmdpop;
        if c='N' then yn := false;
      end else
      begin
        LCDPrintAt(l,center('['+YesStr+'] / '+NoStr));
        repeat
          if keypress then
          begin
            c:=getkey;
            if (c<>chr(EnterChar)) then begin
              yn:=not yn;
              if yn then LCDPrintAt(l,center('['+YesStr+'] / '+NoStr)) else
                LCDPrintAt(l,center(YesStr+'/ ['+NoStr+']'));
            end;
          end;
        until c=chr(EnterChar);
      end;
      YesNo := yn;
    end;

procedure LCDOk(l:byte);
  var
    yn:boolean;
    c:char;
    begin
      yn:=true;
      LCDPrintAt(l,center('['+OKStr+']'));
      repeat
        c:=readkey
      until c=chr(EnterChar);
    end;

function spaces(l:byte):string;
  var b:string;
      a:byte;
  begin
    b:='';
    for a := 1 to l do b:=b+' ';
    spaces := b;
  end;

procedure Help(hmsg:string;var l:byte);
  var
    c:char;
    po:integer;
    begin
      if (not cmdempty) then c:= upcase(cmdnext);
      if (c='#') then
      begin
        cmdpop;
      end else
      begin
        lcdclear;
        delay(50);
        if HelpBoxes then
        begin
          for po := 1 to LCDLEN do hmsg := ' ' + hmsg;
          LCDPrintAt(l,center('['+OKStr+']'));
          c:=' ';
          repeat
            LCDPrintAt(1,copy(hmsg,1,lcdlen));
            hmsg := copy(hmsg,2,length(hmsg)-1)+hmsg[1];
            if keypress then c:=getkey;
            delay(ScrollDelay*2);
          until c=chr(EnterChar);
        end;
      end;
    end;

procedure Info(hmsg:string;l:byte);
  var
    c:char;
    po:integer;
    begin
      if (not cmdempty) then c:= upcase(cmdnext);
      if (c='#') then
      begin
        cmdpop;
      end else
      begin
        lcdclear;
        delay(50);
          for po := 1 to LCDLEN do hmsg := ' ' + hmsg;
          LCDPrintAt(l,center('['+OKStr+']'));
          c:=' ';
          repeat
            LCDPrintAt(1,copy(hmsg,1,lcdlen));
            hmsg := copy(hmsg,2,length(hmsg)-1)+hmsg[1];
            if keypress then c:=getkey;
            delay(ScrollDelay*2);
          until c=chr(EnterChar);
        end;
      end;

procedure DefineStars;
  begin
  delay(50);
  initlcd;
  delay(50);
  lcddefinechar(0, 0,0,0,4,0,0,0,0);
  lcddefinechar(1,  0,0,4,14,4,0,0,0);
  lcddefinechar(2, 0 ,4,14, $1f, 14, 4, 0,0);
  lcddefinechar(3, 4, 4, 14,$1f, 14, 4, 4, 0);
  lcddefinechar(5,  4, 4, 14, $1f, $1f, 14, 4, 4);
  lcddefinechar(4,  0, 4, 14, $1f, $1f, 14, 4, 0);
  lcddefinechar(6, 4, 21, 14, $1f, $1f, 14, 21, 4);
  lcddefinechar(7, 21, 21, 14, $1f, $1f, 14, 21, 21);
  delay(50);
  lcdclear;
end;

procedure eq_bars;
begin
  delay(50);
  initlcd;
  delay(50);

  lcddefinechar(7,  0,0,0,0,0,0,0,31);
  lcddefinechar(6, 0,0,0,0,0,0,31,31);
  lcddefinechar(5, 0,0,0,0,0,31,31,31);
  lcddefinechar(4, 0,0,0,0,31,31,31,31);
  lcddefinechar(3, 0,0,0,31,31,31,31,31);
  lcddefinechar(2, 0,0,31,31,31,31,31,31);
  lcddefinechar(1, 0,31,31,31,31,31,31,31);
  lcddefinechar(0, 31,31,31,31,31,31,31,31);
  delay(20);
  lcdclear;

end;


function Addkey(ins:string):byte;
var a:byte;
    code:integer;
  begin
    if ins[1] = '#' then
      begin
        ins:=copy(ins,2,length(ins));
        val(ins,a,code);
      end
      else a:=ord(ins[1]);
   AddKey := a;
  end;


function center(ab:string):string;
var c:string;
 begin
   c:='';
   c := ab;
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   center := c;
 end;

function stripbeg(s:string):string;
 var dest:string;
     i:integer;

     begin
       i:=1;
       while(s[i] = #32) do inc(i);
       dest := copy(s,i,length(s));
       stripbeg := dest;
     end;

procedure dostar(line:byte);
  begin
    inc(starcount);
    LCDCursor(line,1);
    LCDPrint(stars[starcount]);
    if starcount = length(stars) then starcount := 0;
  end;

function stripend(s:string):string;
  var dest,dest2:string;
      i,c:integer;
  begin
     i:=length(s);

     dest := ''; dest2 := '';
     c:=0;
     while (s[i] = #32) do begin
       inc(c);
       dec(i);
     end;
     dest := copy(s,1,(length(s)-c));
     i:=pos('_',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('_',dest);
     end;

{     for i := 1 to length(dest) do dest[i] := upcase(dest[i]);}
     stripend := dest;
  end;

function UpString(dest:string):string;
  var i:integer;
  begin
     for i := 1 to length(dest) do dest[i] := upcase(dest[i]);
     UpString := dest;
  end;

function GetArtist(sn:string):string;
 var art:string;
     p:word;
  begin
    art := '';
    art := stripend(sn);
    p := pos('-',art);
    if (p=0) then p := length(art)+1;
    art := copy(art,1,p-1);
    if sn='' then art := '';
    GetArtist := art;
  end;

function GetTitle(sn:string):string;
  var thesong:string;
      p:word;
  begin
    thesong := '';
    thesong := stripend(sn);
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    p := pos('-',thesong);;
    if (p=0) then p := length(thesong)+1;
    thesong := copy(thesong,1,p-1);
    if sn='' then thesong := '';
    GetTitle := thesong;
  end;

function GetAlbum(sn:string):string;
  var thesong:string;
  begin
    thesong := '';
    thesong := stripend(sn);
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    thesong := copy(thesong,1,pos('-',thesong)-1);
    if sn='' then thesong := '';
    GetAlbum := thesong;
  end;


function strr(b:longint):string;
  var
   S: string[11];
   begin
    Str(b, S);
    strr := S;
   end;




procedure clear(var asong:song);
  var
    cl:integer;
    begin
      for cl := 0 to SongSize-1 do asong[cl] := #0;
    end;



function strip(s:string; st:char): string;

  var
    l:integer;
    b:string;
    begin
      b:='';
      for l := 1 to length(s) do
        if s[l] <> st then b:=b+s[l];
      strip := b;
    end;

  Procedure NumLock(ONorOFF:Boolean);Assembler;
    asm
    cmp ONorOFF,1
    je @BeLight
    jmp @BeDarkness
    @BeLight:
     MOV SI,40h
     MOV ES,SI
     MOV AL,ES:[0017h]
     OR  AL,20h
     MOV ES,SI
     MOV ES:[0017h],AL
     jmp @FINISH
    @BeDarkness:
     MOV SI,40h
     MOV ES,SI
     MOV AL,ES:[0017h]
     AND AL,0DFh
     MOV ES,SI
     MOV ES:[0017h],AL
    @FINISH:
    end;


Function DosShell(command:String):Integer;Var
 OldHeapEnd,
 NewHeapEnd: Word;
 Error:Integer;
Begin
 Error:=0;
 If MemAvail<$1000 then Error:=8;
 If Error=0 then Begin
  NewHeapEnd:=Seg(HeapPtr^)-PrefixSeg;
  OldHeapEnd:=Seg(HeapEnd^)-PrefixSeg;
   asm
    mov ah,4Ah
    mov bx,NewHeapEnd
    mov es,PrefixSeg
    Int 21h
    jnc @EXIT
    mov Error,ax
    @EXIT:
   end; {asm}
  If Error=0 then begin
   lcdtoscreen := false;
   SwapVectors;
   Exec(GetEnv('COMSPEC'),command);
   SwapVectors;
   lcdtoscreen := true;

    asm
     mov ah,4Ah
     mov bx,OldHeapEnd
     mov es,PrefixSeg
     Int 21h
     jnc @EXIT
     mov Error,ax
     @EXIT:
    end; {asm}
  end;   {If}
 end;    {If}
 DosShell:=Error;
end;     {Function}

procedure AddPlayOptions(var ps:string);
var i:byte;
  begin
{    writeln('Adding options: ');}
      for i := 1 to numplayoptions do begin
        if playoptions[i]^.tag then
          begin
            ps := ps + ' ' + playoptions[i]^.data;
{            write(playoptions[i]^.data,' ');}
          end;
      end;
{      writeln;}
      if debug then readln;
    end;

function GetAlpha:string;
var alpha :string;
    curpos:integer;
    left:integer;
    ch:char;
    build:string;

procedure UpdateLCD;
  var lcdpos:integer;
  begin
    if ((curpos > (lcdlen-2)) and (curpos <= ((lcdlen-2)*2))) then left := (lcdlen-1) else
    if (curpos > ((lcdlen-2)*2)) then left := ((lcdlen-2)*2)+1 else left := 1;
    lcdpos := curpos-left+1;
    lcdprintat(1,' '+copy(alpha,left,lcdlen-2)+' ');
    lcdcursor(1,lcdpos);
    lcdprint(chr(255));
    lcdcursor(1,lcdpos+2);
    lcdprint(chr(255));
    lcdprintat(2,'->'+build+' ');
    lcdcursor(2,length(build)+3);
  end;

begin
  LCDCursorOn;
  alpha := '*-ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789        ';
  LCDClear;
  build := '';
  left := 1;
  curpos := 3;
  updateLCD;
  repeat

    if keypress then begin
      ch:=getkey;
      if ch = chr(RightChar) then inc(curpos);
      if ch = chr(LeftChar) then dec(curpos);
      if (curpos > 38) then curpos:= 1;
      if (curpos < 1) then curpos := 38;

      if ((ch=chr(EnterChar)) and (curpos = 2)) or (ch=chr(ExitChar)) then build := copy(build,1,length(build)-1) else
      if (ch=chr(EnterChar)) and (curpos <> 1) then build := build + alpha[curpos];
      updateLCD;
    end;
    drawmpxtlogo;
  until (curpos = 1) and (ch=chr(EnterChar));
  GetAlpha := build;
  lcdcursoroff;
  delay(10);
  end;

begin
end.
