unit MPXFDB;
{
 MPXF Database Unit

 Another fine unit made by Scott Bradshaw
}

interface
uses
 mpxfvars;
function SelectDrive:string;
procedure AddFiles;
procedure PickDatabase;
procedure LoadDatabase(mp3list:string);
procedure DatabaseInfo;
procedure PromptSaveDatabase;
procedure ClearDatabase;
procedure SortDatabase(method:byte);
procedure BrowseDrive;
function DirBrowse:string;
function getsonginfo(position:integer) : songname;
function getsongpath(position:integer) : songname;
function MenuSelect(TheMenu:menu; choices:integer) : integer;
procedure AddData(var data:string);
implementation
uses LCD,dos{,mpxfmenu},crt,mpxfmem,mp3tag,xms,mpxfcprc;
Var
  Regs :Registers;            (* To hold register info For Intr() *)
  type songarray=array[1..200] of char;

  mpxfile=file of songarray;

  const
    searchorder ='()_-!0123456789ABCDEFGHIJKLMNOPQRSTUVWXZY';

function getsonginfo(position:integer) : songname;
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    WriteLn('Error on XMSGetDataFrom, getsonginfo, handle=', h, ' totalsongs=',totalsongs)
    ELSE begin
       ret := Data[where];
       ret := copy(ret,1,length(ret)-1);
       ret:=copy(ret,101,200);
    end;
    if position = 0 then ret := '';
    getsonginfo := ret;
  end;

function getsongall(position:integer) : songname;
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    WriteLn('Error on XMSGetDataFrom, getsonginfo, handle=', h, ' totalsongs=',totalsongs)
    ELSE begin
       ret := Data[where];
       ret := copy(ret,1,length(ret)-1);
    end;
    getsongall := ret;
  end;


procedure PrepareAdd;
var
      ret:songname;

  begin
    ret := getsonginfo(totalsongs);
  end;


procedure putsongat(position:integer;thesong:song);
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
      puts:song;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    begin
      WriteLn('Error on XMSGetDataFrom, getsongpath, handle=', h);
      delay(2000);
    end
    ELSE begin
        clear(puts);
        puts:=thesong;
        data[where] := puts;
        savemem(h+1);
    end;
  end;

procedure putsong(thesong:song);
  var puts:song;
      ret:songname;
      mb:word;

  begin
    clear(puts);
    puts:=thesong;
    inc(xmscount);
    data[xmscount] := puts;
    if (xmscount=maxmem) then begin
      xmscount := 0;
      inc(memblocks);
      savemem(memblocks);
    end;
  end;


function getsongpath(position:integer) : songname;
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    WriteLn('Error on XMSGetDataFrom, getsongpath, handle=', h)
    ELSE begin
       ret := Data[where];
       ret := copy(ret,1,length(ret)-1);
       ret:=copy(ret,1,100);
    end;
    getsongpath := ret;
  end;


Function GetDrive :Byte;
                (* Routine to Determine the default drive             *)
begin
  Regs.AX := $1900;                (* Function to determine drive     *)
  Intr($21,Regs);                  (* Call Dos int 21h                *)
  GetDrive := Regs.AL;             (* Return Proper result            *)
        (* Returns  0 = A, 1 = B, 2 = C, ETC                          *)
end;

Function NumDrives :Byte;
                (* Routine to determine number of valid drives        *)
Var
  CurDrive :Byte;             (* Temporary storage For current drive*)
begin
  CurDrive := GetDrive;         (* Find out the current drive         *)
  Regs.AH := $0E;               (* Function to change drives          *)
  Regs.DL := CurDrive;          (* Change to current drive            *)
  Intr($21, Regs);              (* Call Dos                           *)
  NumDrives := Regs.AL;         (* Return proper info to user         *)
end;


function getmp3(const d:string;rec:boolean):word;
  var sr:searchrec;
      ss:string;
      count:word;
      so:string;
{
    procedure dofilesearch;   Old MPXF1.4 Way
      var spc:integer;
          so:string;
    begin
      spc := 0;
        findfirst(d+'*.MP3',archive+readonly,sr);
        while (doserror=0) do begin
          inc(count);
          findnext(sr);
        end;
    end;}

    procedure dofilesearch; {New way, which supports multiple file extensions}
      var spc:integer;
          so:string;
    begin
      spc := 0;
        findfirst(d+'*.*',archive+readonly,sr);
        while (doserror=0) do begin
          if (copy(sr.name,length(sr.name)-3,4)='.MP3') OR
             (copy(sr.name,length(sr.name)-3,4)='.MP2') OR
             (copy(sr.name,length(sr.name)-3,4)='.APE') OR
             (copy(sr.name,length(sr.name)-3,4)='.WAV') OR
             (copy(sr.name,length(sr.name)-3,4)='.AC3') OR
             (copy(sr.name,length(sr.name)-3,4)='.MPC') OR
             (copy(sr.name,length(sr.name)-3,4)='.AAC') OR
             (copy(sr.name,length(sr.name)-3,4)='.OGG')
           then
            inc(count);
          findnext(sr);
        end;
    end;

    procedure dodirsearch;
      var spc:integer;
          so:string;
    begin
        findfirst(d+'*.*',directory,sr);
        while doserror=0 do begin
        {'writeln(sr.name);}
          if (sr.attr and directory = directory)
          and (sr.name[1]<>'.') then begin              { ignores "." and ".." }
            count := count + getmp3(d+sr.name+'\',rec);
          end;
            findnext(sr);
        end;
    end;

  begin {dosearch}
    count := 0;
    dofilesearch;
    if rec then dodirsearch;
    getmp3 := count;
  end;

procedure AddtoDB(const d:string;rec:boolean);
  var sr:searchrec;
      ss:string;
      count:word;
      so:string;

    procedure dofilesearch;
      var spc,c:integer;
          ts:song;
    begin
      for c := 1 to length(so) do
      begin
{Old MPXF 1.4 Way}
{        findfirst(d+so[c]+'*.MP3',archive+readonly,sr);
        while (doserror=0) do begin
          inc(count);
          for spc := 1 to 200 do ts[spc] := ' ';
          ss:=d+sr.name;
          inc(totalsongs);
          for spc := 1 to length(ss) do ts[spc] := ss[spc];
           ss:=songinfo(d+sr.name);
           if ss='NoTag' then ss:=NoStr+' ID3 Tag-'+d+sr.name;
{        writeln(ss);}
{           for spc := 1 to length(ss) do ts[spc+100] := ss[spc];
           putsong(ts);
           findnext(sr);
         end;}

{New MPXT 1.5 Way, supports multiple file extensions}
        findfirst(d+so[c]+'*.*',archive+readonly,sr);
        while (doserror=0) do
         begin
          if (copy(sr.name,length(sr.name)-3,4)='.MP3') OR
             (copy(sr.name,length(sr.name)-3,4)='.MP2') OR
             (copy(sr.name,length(sr.name)-3,4)='.APE') OR
             (copy(sr.name,length(sr.name)-3,4)='.WAV') OR
             (copy(sr.name,length(sr.name)-3,4)='.AC3') OR
             (copy(sr.name,length(sr.name)-3,4)='.MPC') OR
             (copy(sr.name,length(sr.name)-3,4)='.AAC') OR
             (copy(sr.name,length(sr.name)-3,4)='.OGG') then
           Begin
            inc(count);
            for spc := 1 to 200 do ts[spc] := ' ';
            ss:=d+sr.name;
            inc(totalsongs);
            for spc := 1 to length(ss) do ts[spc] := ss[spc];
            ss:=songinfo(d+sr.name);
            if ss='NoTag' then ss:=NoStr+' ID3 Tag-'+d+sr.name;
{        writeln(ss);}
            for spc := 1 to length(ss) do ts[spc+100] := ss[spc];
            putsong(ts);
           End;
          findnext(sr);
         end;

       end;
     end;

    procedure dodirsearch;
      var spc:byte;
    begin
      for spc := 1 to length(so) do
      begin
        findfirst(d+so[spc]+'*.*',directory,sr);
        while doserror=0 do begin
          {writeln(sr.name);}
          if (sr.attr and directory = directory)
          and (sr.name[1]<>'.') then begin              { ignores "." and ".." }
            AddtoDB(d+sr.name+'\',rec);
          end;
            findnext(sr);
         end;
      end;
      end;

  begin {dosearch}
      so:=searchorder;
    count := 0;
    dofilesearch;
    if rec then dodirsearch;
  end;

function SonginDB(f:string):word;
 var
   tf:mpxfile;
   a:longint;
   begin
     a:=0;
     assign(tf,f);
     reset(tf);
     a:= FileSize(tf)-1;
     close(tf);
     SonginDB := a;
   end;



procedure SaveDatabase(mp3list:string);
var onesong:song;
    position :word;
    infile:file of song;
    l:word;
    sn:songname;
  begin
{  Save Songs from XMS }
    if (totalsongs = 0) then begin
      LCDClear;
      LCDPrintAt(1,center(NoStr+' '+Songsstr+'!'));
      LCDOk(2);
    end else
    begin
      assign(infile,Databasedir+mp3list);
      {$I-} rewrite(infile); {$I+}
      for position := 1 to totalsongs do begin
        sn := getsongpath(position);
        for l := 1 to songsize do onesong[l] := ' ';
        for l := 1 to SongSize do onesong[l] := sn[l];
        sn := getsonginfo(position);
        for l := 1 to SongSize do onesong[l+100] := sn[l];
        seek(infile,position);
        write(infile,onesong);
      end;
      close(infile);
    end;
  end;


procedure PromptSaveDatabase;
 var filename:string;
  begin
    if DefaultDatabase = DatabaseEmpty then
    begin
      LCDClear;
      LCDPrintAt(1,'Save '+strr(totalsongs)+' '+songsstr+'.');
      LCDPrintAt(2,'Enter Filename:');
      delay(2000);
      filename := getalpha;
      LCDClear;
      if length(filename) = 0 then exit;
      LCDPrintAt(1,'Saving...');
      DefaultDatabase := copy(filename,1,8)+'.m3d';
      SaveDatabase(DefaultDatabase);
    end else begin
      LCDClear;
      delay(10);
      LCDPrintAt(1,'Save as:'+copy(DefaultDatabase,1,pos('.',defaultdatabase)-1));
      if YesNo(2) then
      begin
        LCDClear;
        LCDPrintAt(1,'Saving.');
        SaveDatabase(DefaultDatabase)
      end else
      begin
        LCDClear;
        LCDPrintAt(1,'Save '+strr(totalsongs)+' '+songsstr+'.');
        LCDPrintAt(2,'Enter Filename:');
        delay(2000);
        filename := getalpha;
        LCDClear;
        if length(filename) = 0 then exit;
        LCDPrintAt(1,'Saving...');
        DefaultDatabase := copy(filename,1,8)+'.m3d';
        SaveDatabase(DefaultDatabase);
      end;
    end;
  end;


procedure LoadDatabase(mp3list:string);
var onesong:song;
    position :word;
    infile:file of song;
  begin
{  Load Songs into XMS }
  defaultdatabase:=mp3list;
  assign(infile, databasedir+mp3list);
  {$I-} reset(infile); {$I+}
  if IOResult <> 0 then begin
    Info('Database not found.',2);
{    ReleaseXMS;
    halt(1);}
  end else
  begin
    PrepareAdd;
    for position := 1 to filesize(infile)-1 do begin
      {$I-} seek(infile,position);{$I+}
      if IOResult = 0 then
      begin
        read(infile,onesong);
        inc(totalsongs);
        putsong(onesong);
        if (totalsongs mod (SearchBar*2)) = 0 then LCDPrint('.');
      end;
    end;
    close(infile);
    SetXMSMemory;
    LCDCursorOff;
    LCDPrintAt(2,center(strr(totalsongs)+' '+songsstr+'.'));
  end;
  end;

procedure ClearDatabase;
  begin
    Lcdclear;
    LCDPrintAt(1,'Are you sure?');
    if YesNo(2) then begin
      totalsongs := 0;
      memblocks := 0;
      xmscount := 0;
      DefaultDatabase:='No Name';
      lcdclear;
      LCDPrintAt(1,'Database Clear');
      LCDOk(2);
    end;
  end;

procedure DatabaseInfo;
var i:word;
  begin
    LCDCoolClear;
    Info(defaultdatabase+' - '+(strr(totalsongs)+' '+songsstr+'.'),2);
  end;


procedure AddData(var data:string);
var p:byte;
    a1,a2:string;
    add:string;

    procedure ProcessKey(key,replace:string);

      begin
        if pos(key,upstring(data)) > 0 then
        begin
           p := pos(key,upstring(data));
           a1 := copy(data,1,p-1);
           a2 := copy(data, p + length(key), length(data));
           data := a1 + replace + a2;
        end;
      end;

    begin
      PlayOptionData := '';
      AddPlayOptions(PlayOptionData);
      if Helpboxes then add := YesStr else add := NoStr;
      ProcessKey('$HELPBOXES',add);
      if GenreSupport then add := YesStr else add := NoStr;
      ProcessKey('$USEGENRES',add);
      ProcessKey('$FILEINFO', PlayData);
      ProcessKey('$PLAYOPTIONS', PlayOptionData);
      ProcessKey('$MP3PROG',mp3prog);
    end;

function MenuSelect(TheMenu:menu; choices:integer) : integer;
  var
    i:integer;
    cs:string;
    ch:char;
    tag:word;
    CurrentChoice:word;
    iReturn:integer;
    PrintLine:byte;
    br1,br2:string;
    brp:byte;
    aa:string;
    cv:byte;
    code:integer;

    function center(s:string):string;
      var l:integer;
          space:integer;
          ret:string;
      begin
        ret := s;
        l := length(s);
        if (l < lcdlen) then begin
          space := LCDLen-l;
          space := space div 2;
          ret := s;
          for l := 1 to space do ret := ' ' + ret + ' ';
        end else center := s;
        center := ret;
     end;



    procedure Update;
      var sn:string;
          Album:string;
          Artist:string;
          i,b,a :integer;
      begin
        lcdclear;
        lcdcursoroff;
        gotoxy(1,12);
        writeln('                     Processing Menu: ['+NextMenu+']');

       if (CurrentChoice = choices) and (Choices >= LCDLines) then begin
          for i := CurrentChoice-1 downto CurrentChoice-LCDLines+1 do
            LCDPrintAt(LCDLines-(CurrentChoice-i),center(TheMenu[i]));
          LCDPrintAt(LCDLines,center('['+TheMenu[CurrentChoice]+']'));
          PrintLine := LCDLines;
       end else
       if ((Choices-CurrentChoice) < LCDLines-1) and (Choices>=LCDLines) then begin
         b := choices-currentchoice;
         a := lcdlines - b;
         for i := 1 to a-1 do
           LCDPrintAt(i, center(TheMenu[Choices-lcdlines+i]));
         LCDPrintAt(a, center('['+TheMenu[CurrentChoice]+']'));
         PrintLine := a;
         for i := a+1 to LCDLines do
           LCDPrintAt(i,center(TheMenu[Choices+-lcdlines+i]));
       end else
       begin
          LCDPrintAt(1,center('['+TheMenu[CurrentChoice]+']'));
          PrintLine := 1;
          for i := 2 to LCDLines do
            if ((i-1+currentchoice)<=choices) then
            LCDPrintAt(i,center(TheMenu[CurrentChoice+i-1]))
            else
              LCDPrintAt(i,spaces(LCDLen));
       end;
      end;

  begin
    cv := 0;
    if (not cmdempty) then
    begin
      ch:= upcase(cmdnext);
      aa := ch;
      val(aa,cv,code);
    end;
    if (cv > 0) then
    begin
      cmdpop;
      MenuSelect := cv;
    end else
    begin
      for i := 1 to Choices do
      begin
        aa := TheMenu[i];
        AddData(aa);
        TheMenu[i] := aa;
{        AddData(TheMenu[i]);}
      end;
      brp:=1;
      br1:='>]-';
      br2:='<[-';
      delay(50);
      InitLCD;
      delay(50);
      LCDCoolClear;
      LCDCursorOFF;
      CurrentChoice:=1;
      Update;
      iReturn := 0;
      repeat
        ch := ' ';
        if keypress then ch:=getkey;
        if ch=#27 then ch:=chr(ExitChar);
        if (ch=chr(UpChar)) then
          begin
            if CurrentChoice = 1 then CurrentChoice := Choices
              else dec(CurrentChoice);
            Update;
          end;
        if (ch=chr(DownChar)) then
        begin
          if CurrentChoice = Choices then CurrentChoice := 1 else
            inc(CurrentChoice);
          Update;
        end;
    {$IFNDEF notwirl}
        LCDPrintAt(PrintLine,center(br1[brp]+TheMenu[CurrentChoice]+br2[brp]));
        delay(60);
    {$ENDIF}
        inc (brp);
        if brp = 4 then begin
          brp := 1;
          DrawMPXTLogo;
        end;
       until (ch=chr(EnterChar)) or (ch=chr(ExitChar));
       if (ch = chr(ExitChar)) then MenuSelect := choices else MenuSelect := CurrentChoice;
   { // Check if user got out // }
   end;

 end;




procedure PickDatabase;
var lists:menu;
    numlists:word;
    pick:word;
    numsongs:word;
    inp:string;
    t:text;
    code:integer;
    allsongs:word;
    SongCount:word;
    entry:string;

var
 DirInfo: SearchRec;
begin
  LCDClear;
  Help('Select the database to load. Database files have the extension .m3d',LCDLines);
  LCDPrintAt(1,LoadingStr+'..');
  numlists := 0;
  FindFirst(DatabaseDir+'*.m3d', Archive, DirInfo);
  while DosError = 0 do
  begin
    inc(numlists);
    entry := copy(DirInfo.Name,1,length(DirInfo.name)-4);
    lists[numlists] := entry + '('+strr(SonginDB(entry+'.m3d'))+')';
    FindNext(DirInfo);
    if (numlists=9) then LCDCursor(2,1);
    LCDPrint('.');
  end;
  LCDClear;
  If numlists = 0 then begin
    LCDPrintAt(1,NoStr+' Databases.');
    LCDOk(2);
  end else begin
     inc(numlists);
     lists[numlists] := '-EXIT-';
     pick := menuselect(lists,numlists);
     if pick <> numlists then begin
       lcdclear;
       lcdprintat(1,LoadingStr+'.');
       LoadDatabase(copy(lists[pick],1,pos('(',lists[pick])-1)+'.m3d');
      end;
      LCDCursorOff;
      delay(1000);
      LCDClear;
  end;
 end;

function validdrive(s:string):boolean;
  begin
    {$I-}
    chdir(s);
    if IOResult <> 0 then validdrive := false else validdrive := true;
  end;

function SelectDrive:string;
    var mmchar:integer;
      main:^menu;
      savedir:string;
      i:integer;
      totald,d:byte;
      dir:string;
 begin
   new(main);
   totald:=0;
   getdir(0,savedir);
   for i := 3 to numdrives do begin
     dir := chr(i+64)+':\';
     if not validdrive(dir) then
       begin
       chdir(savedir) end else
     begin
       inc(totald);
       main^[totald] := chr(i+64)+ ' drive';
     end;
   end;
   chdir(savedir);
   inc(totald);
   main^[totald] := 'Exit';
   d:=menuselect(main^,totald);
   if d = totald then dir := '0' else
     dir := main^[d][1]+':\';
   dispose(main);
   selectdrive := dir;
 end;

function DirBrowse:string;
  var
    i:integer;
    cs:string;
    totald:byte;
    selectmenu:^menu;
    ch:char;
    tag,d:word;
    savedir,dir:string;
    CurrentChoice:word;
    Choices:word;
    iReturn:integer;
    thedrive:string;
    oldpath:string;
    code:integer;
    sr:searchrec;
    pickit:integer;
    mp3count:word;
    dircount:word;
    Refresh:boolean;
    startdrive:boolean;
    so:string;
    spc:integer;
    cv:byte;
    aa:string;


    function center(s:string):string;
      var l:integer;
          space:integer;
          ret:string;
      begin
        ret := '';
        l := length(s);
        space := LCDLen-l;
        space := space div 2;
        for l := 1 to space do ret := ret + ' ';
        ret := ret + s;
        for l := 1 to space do ret := ret + ' ';
        center := ret;
     end;



    procedure Update;
      var sn:string;
          Album:string;
          Artist:string;
          i,b,a :integer;
          PrintLine:byte;
      begin
        lcdclear;
       if (CurrentChoice = choices) and (Choices >= LCDLines) then begin
          for i := CurrentChoice-1 downto CurrentChoice-LCDLines+1 do
            LCDPrintAt(LCDLines-(CurrentChoice-i),' '+SelectMenu^[i]);
          LCDPrintAt(LCDLines,'>'+SelectMenu^[CurrentChoice]);
          PrintLine := LCDLines;
       end else
       if ((Choices-CurrentChoice) < LCDLines-1) and (Choices>=LCDLines) then begin
         b := choices-currentchoice;
         a := lcdlines - b;
         for i := 1 to a-1 do
           LCDPrintAt(i, ' '+SelectMenu^[Choices-lcdlines+i]);
         LCDPrintAt(a, '>'+SelectMenu^[CurrentChoice]);
         PrintLine := a;
         for i := a+1 to LCDLines do
           LCDPrintAt(i,' '+SelectMenu^[Choices+-lcdlines+i]);
       end else
       begin
          LCDPrintAt(1,'>'+SelectMenu^[CurrentChoice]);
          PrintLine := 1;
          for i := 2 to LCDLines do
            if ((i-1+currentchoice)<=choices) then
            LCDPrintAt(i,' '+SelectMenu^[CurrentChoice+i-1])
            else
              LCDPrintAt(i,spaces(LCDLen));
       end;
      end;

  begin
    so:=searchorder;
    Refresh := False;
{    LCDtoSCreen := False;}
    CurrentChoice:=1;
    new(selectmenu);
    startdrive:=true;
    thedrive := ''; { Pick the drive first }
    oldpath := thedrive;
    repeat
      if startdrive then
      begin
         LCDClear;
         LCDPrintAt(1,center('Scanning'));
         LCDPrintAt(2,center('Drives...'));
         currentchoice := 1;
         totald:=0;
         getdir(0,savedir);
         for i := 3 to numdrives do begin
           dir := chr(i+64)+':\';
           {$I- } chdir(dir); {$I+}
           if IOResult = 0 then
           begin
             inc(totald);
             selectmenu^[totald] := chr(i+64)+ ' drive ('+strr(getmp3(chr(i+64)+':\',true))+')';
           end;
         end;
         chdir(savedir);
         inc(totald);
         selectmenu^[totald] := 'Exit';
         choices := totald;
         Update;
         startdrive := false;
      end;
      if Refresh then
      begin
        lcdclear;
        lcdcursoroff;
        LCDPrintAt(1,LoadingStr+'...');
        delay(200);
        Choices := 0;
        CurrentChoice:=1;
        selectmenu^[1] := '        ';
        selectmenu^[2] := '        ';
        { Count the files }
{        findfirst(thedrive+'*.*',directory,sr);
        if doserror<>0 then thedrive := oldpath;}
        for spc := 1 to length(so) do
        begin
          findfirst(thedrive+so[spc]+'*.*',directory,sr);
          while doserror=0 do begin
            if (sr.attr and directory = directory) then
            if (sr.name[1]<>'.') then
            begin
              inc(Choices);
              selectmenu^[choices] := sr.name +
              '('+strr(getmp3((thedrive+sr.name+'\'),false))+'/'+strr(getmp3((thedrive+sr.name+'\'),true))+')';
            end;
            findnext(sr);
          end;
        end;
        Update;
        Refresh := False;
       end;

    ch := ' ';
    cv := 0;
    if (not cmdempty) then
    begin
      ch:= upcase(cmdnext);
      aa := ch;
      val(aa,cv,code);
    end;
    if (cv > 0) then
    begin
      cmdpop;
      Currentchoice := cv;
      ch := chr(EnterChar);
    end else
    begin
      if keypress then ch:=getkey;
      if (ch=chr(UpChar)) and (CurrentChoice <> 1) then
        begin
          dec(CurrentChoice);
          Update;
        end;
      if (ch=chr(DownChar)) and (CurrentChoice <> Choices) then
        begin
          inc(CurrentChoice);
          Update;
        end;
      if (ch=chr(LeftChar)) then
        begin
          thedrive := oldpath;
          if thedrive = '' then startdrive := true else
          Refresh := true;
        end;
      if (ch=chr(RightChar)) then
        begin
          if (thedrive = '') then
            begin
              oldpath := '';
              thedrive := selectmenu^[currentchoice][1]+':\';
              Refresh:=true;
            end else
            begin
              findfirst(thedrive+copy(selectmenu^[currentchoice],1,pos('(',selectmenu^[currentchoice])-1)+'\*.*',directory,sr);
              while ((sr.attr and directory = directory)
                 and (sr.name[1]='.')) do findnext(sr);              { ignores "." and ".." }
              if (doserror = 0) and (sr.attr and directory = directory) then
                begin
                  oldpath := thedrive;
                  thedrive := thedrive + copy(selectmenu^[currentchoice],1,pos('(',selectmenu^[currentchoice])-1) + '\';
                  Refresh := true;
                end;
            end;
          end;
       delay(10);
     end;
     until (ch=chr(EnterChar)) or (ch=chr(ExitChar));
     if (ch=chr(EnterChar)) then
     begin
       if (thedrive = '') then
         if (currentchoice=choices) then ch:=chr(ExitChar) else
           thedrive := selectmenu^[currentchoice][1]+':\'
         else
         if (thedrive <> '') then
           thedrive := thedrive+copy(selectmenu^[currentchoice],1,pos('(',selectmenu^[currentchoice])-1)+'\';
     end;
   if ch=chr(ExitChar) then thedrive := '';
   dispose(selectmenu);
   DirBrowse := thedrive;
 end;

procedure AddFiles;
{
  This prompts the user for the drives and directories.
  It will add the files in memory to the current database.
}
  var thedrive:string;
      startdrive:string;
      oldpath:string;
      sr:searchrec;
      pickit:integer;
      mp3count:word;
      dircount:word;
      pathtoadd:string;
      part,full:word;

  begin
    lcdclear;
    pathtoadd := '';
    pathtoadd := DirBrowse;
    if pathtoadd <> '' then
    begin
      LCDClear;
      LCDPrintAt(1,LoadingStr+'...');
      part := getmp3(pathtoadd,false);
      full := getmp3(pathtoadd,true);
      Help('Choose if you want to recurse folders.',LCDLines);
      Help('Doing so will add '+strr(full)+
      ' songs, while '+strr(part)+
      ' songs without.',LCDLines);
      LCDClear;
      LCDPrintAt(1,center('Add subfolders?'));
      if YesNo(2) then
      begin
        LCDClear;
        LCDPrintAt(1,'Adding '+strr(full) + ' files.');
        PrepareAdd;
        AddtoDB(pathtoadd,true)
      end else
      begin
        LCDClear;
        LCDPrintAt(1,'Adding '+strr(part) + ' files.');
        PrepareAdd;
        AddtoDB(pathtoadd,false);
      end;
      SetXMSMemory; { Refresh it baby !}
      LCDClear;
      LCDPrintAt(1,'Save changes?');
      if YesNo(2) then PromptSaveDatabase;
    end;
  end;

procedure BrowseDrive;
{
  This prompts the user for the drives and directories.
  It will add the files in memory to the current database.
}
  var thedrive:string;
      pathtoadd:string;
      s:string;
      sch:byte;
      smenu:^menu;


  begin
    lcdclear;
{    pathtoadd := '';
    pathtoadd := DirBrowse;
    if pathtoadd <> '' then
    begin
      lcdclear;
      new(smenu);
      smenu^[1] := 'Play Normal';
      smenu^[2] := 'Play Random';
      smenu^[3] := 'Cancel';
      LoadMenu('Play Options',3,smenu^);
      sch := menuselect(smenu^,3);
      dispose(smenu);
       s:='';
      if sch = 2 then
        s:=mp3prog + ' ' + mpxplaylistrandom + ' ' +pathtoadd+ '*.mp3'
       else  if sch = 1 then s:=mp3prog + ' ' +mpxplaylistnormal + ' ' +pathtoadd+'*.mp3';}
       lcdclear;
        LCDPrintAt(1,LoadingStr+'...');
        numlock(false);
        s:=mp3prog + ' ' + mpxplaylistnormal;
        if s <> '' then shell(s);
{    end;}
  end;

function SortBy(method,position:integer):string;
  begin
    case method of
      1: sortby := getartist(getsonginfo(position));
      3: sortby := gettitle(getsonginfo(position));
      2: sortby := getalbum(getsonginfo(position));
      4: sortby := copy(getsongpath(position),4,100);
    end;
  end;

function LessThan(s1,s2:string):boolean;
{
  Puts No ID3 tag MP3s at very end
}
var
  lt:boolean;
  begin
    lt:=false;
    if (copy(s1,1,1)=' ') and (copy(s2,1,6)='No ID3') then lt := true else
    if (copy(s1,1,1)=' ') then lt := false else
    if (copy(s2,1,1)=' ') and (copy(s1,1,6)='No ID3') then lt := false else
    if copy(s2,1,1)=' ' then lt := true else
    if (copy(s1,1,1)='') and (copy(s2,1,6)='No ID3') then lt := true else
    if s1 = '' then lt:= false else
    if (copy(s2,1,1)='') and (copy(s1,1,6)='No ID3') then lt := false else
    if s2 = '' then lt:= true else
    if copy(s1,1,6)='No ID3' then lt:= false else
    if s1=s2 then lt := false else
    if copy(S2,1,6)='No ID3' then lt:= true else
      lt := (s1 < s2);

    LessThan := lt;
  end;

Procedure QuickSort(method,woLeft, woRight : Word);
Var
  Pivot: string;
  TempItem:song;
  TempItem2:song;
    s1,s2:songname;
  woIndex1,
  woIndex2 : Word;
  rets:string;
  spc:byte;
begin
  woIndex1 := woLeft;
  woIndex2 := woRight;
  rets := sortby(method,(woLeft + woRight) div 2);
  Pivot := rets;

  Repeat
{    write('[',woIndex1, ' ', woindex2,'] ');}
    While (LessThan(sortby(method,woIndex1),Pivot)) do
      inc(woIndex1);
    While (LessThan(Pivot,sortby(method,woIndex2))) do
      dec(woIndex2);
    if (woIndex1 <= woIndex2) then
      begin
          s1 := getsongpath(woIndex1);
          s2 := getsonginfo(woIndex1);
          for spc := 1 to 200 do TempItem[spc] := ' ';
          for spc := 1 to length(s1) do TempItem[spc] := s1[spc];
          for spc := 1 to length(s2) do TempItem[spc+100] := s2[spc];

          s1 := getsongpath(woIndex2);
          s2 := getsonginfo(woIndex2);
          for spc := 1 to 200 do TempItem2[spc] := ' ';
          for spc := 1 to length(s1) do TempItem2[spc] := s1[spc];
          for spc := 1 to length(s2) do TempItem2[spc+100] := s2[spc];

          putsongat(woIndex1,TempItem2);
          putsongat(woIndex2,TempItem);

{        arData[woIndex1] := arData[woIndex2];
        arData[woIndex2] := TempItem;}
        inc(woIndex1);
        dec(woIndex2)
      end
    Until (woIndex1 > woIndex2);
    if (woLeft < woIndex2) then
      QuickSort(method,woLeft, woIndex2);
    if (woIndex1 < woRight) then
      QuickSort(method,woIndex1, woRight)
end;        (* QuickSort.                                           *)

procedure SortDatabase(method:byte);
var
  s1,s2:songname;
  s:song;
  spc :byte;
begin
  QuickSort(method,1,totalsongs);
end;

begin
end.
